import java.io.*;
import java.util.*;

public class BSol {

    static boolean equal(char[][] a, char[][] b) {
	boolean result = true;
	//System.out.println();
	for (int r = 0; r < 5; ++r) {
	    for (int c = 0; c < 5; ++c) {
		result &= (a[r][c] == b[r][c]);
		//System.out.print(" " + a[r][c] + b[r][c]);
	    }
	    //System.out.println();
	}
	//System.out.println();
	return result;
    }

    static boolean findLegal(char[][] from, char[][] dest, char player) {
	for (int r = 0; r < 5; ++r) {
	    for (int c = 0; c < 5; ++c) {
		if (from[r][c] == player && dest[r][c] != player) {
		    char[][] test = new char[5][5];
		    for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j)
			test[i][j] = from[i][j];
		    
		    test[r][c] = '.';
		    if (r > 0) {
			test[r-1][c] = player;
			if (equal(test, dest)) return true;
			test[r-1][c] = from[r-1][c];
		    }
		    if (c > 0) {
			test[r][c-1] = player;
			if (equal(test, dest)) return true;
			test[r][c-1] = from[r][c-1];
		    }
		    if (r < 4) {
			test[r+1][c] = player;
			if (equal(test, dest)) return true;
			test[r+1][c] = from[r+1][c];
		    }
		    if (c < 4) {
			test[r][c+1] = player;
			if (equal(test, dest)) return true;
			test[r][c+1] = from[r][c+1];
		    }
		}
	    }
	}
	return false;
    }

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	int n = Integer.parseInt(in.readLine());
	
	char[][] last = new char[5][5];
	for (int r = 0; r < 5; ++r) {
	    String line = in.readLine();
	    for (int c = 0; c < 5; ++c) {
		last[r][c] = line.charAt(c);
	    }
	}
	
	boolean[] cheating = new boolean[15];

	char player = '1';
	while (!in.readLine().equals("======")) {
	    char[][] curr = new char[5][5];
	    for (int r = 0; r < 5; ++r) {
		String line = in.readLine();
		for (int c = 0; c < 5; ++c) {
		    curr[r][c] = line.charAt(c);
		}
	    }

	    if (!findLegal(last, curr, player)) {
		cheating[player - '0'] = true;
	    }
	    
	    last = curr;
	    if (++player > '9') player = '1';
	}
	
	StringBuffer out = new StringBuffer();
	out.append("The cheating player(s) is/are: ");
	boolean first = true;
	for (int i = 1; i <= n; ++i) if (cheating[i]) {
	    if (first) first = false; else out.append(", ");
	    out.append(i);
	}
	out.append(".");
	if (first) System.out.println("Nobody cheated!");
	else System.out.println(out.toString());
    }
};
